!  Copyright (C) 2019-2021, respective authors of MCFM.
!
!  This program is free software: you can redistribute it and/or modify it under
!  the terms of the GNU General Public License as published by the Free Software
!  Foundation, either version 3 of the License, or (at your option) any later
!  version.
!
!  This program is distributed in the hope that it will be useful, but WITHOUT ANY
!  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
!  PARTICULAR PURPOSE. See the GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License along with
!  this program. If not, see <http://www.gnu.org/licenses/>
 
      subroutine check_qqb_gam2j_gvecx_new(p,n,in,msqv)
      implicit none
      include 'types.f'
      include 'constants.f'
      include 'mxpart.f'
      include 'nf.f'
      include 'pp.f'
      integer in,j,k
      real(dp):: msqv(-nf:nf,-nf:nf),p(mxpart,4),n(4)
      real(dp):: msqv_cs(0:2,-nf:nf,-nf:nf),ppmsqvx(ppmax)
      logical swap56
      common/swap56/swap56
!$omp threadprivate(/swap56/)

      call qqb_gam2j_gvecx_new(p,n,in,msqv,msqv_cs,ppmsqvx)

! swap56 is a variable which, if true, returns the matrix elements
! with 5 and 6 in the 'unnatural' ordering not usually provided by msqv_cs

! The detailed flavor matrix ppmsqvx is only returned as the sum of all
! color structures in gvecx routine, so if we're doing swap56 then simply
! put result in color structure 1, with 0 and 2 being zeroed later anyway

!--- Only pick out Gflag pieces
      do j=-4,4
      do k=-4,4
      
      if     ((j==0) .and. (k==0)) then
        if (swap56) then
          msqv_cs(1,j,k)=3._dp*ppmsqvx(pp(j,k,1,-1))
     &                  +2._dp*ppmsqvx(pp(j,k,2,-2))
        else
          ! msqv_cs already filled
        endif
      elseif ((j>0) .and. (k<0)) then
        if (swap56) then
          msqv_cs(1,j,k)=msqv_cs(0,j,k)+msqv_cs(1,j,k)+msqv_cs(2,j,k)
        else
          ! msqv_cs already filled and only one ordering is necessary
        endif
      elseif ((j<0) .and. (k>0)) then
        if (swap56) then
          msqv_cs(1,j,k)=msqv_cs(0,j,k)+msqv_cs(1,j,k)+msqv_cs(2,j,k)
        else
          ! msqv_cs already filled and only one ordering is necessary
        endif
      elseif ((j>0) .and. (k==0)) then
        if (swap56) then
          msqv_cs(1,j,k)=ppmsqvx(pp(j,k,k,j))
        else
          ! msqv_cs already filled
        endif
      elseif ((j<0) .and. (k==0)) then
        if (swap56) then
          msqv_cs(1,j,k)=ppmsqvx(pp(j,k,k,j))
        else
          ! msqv_cs already filled
        endif
      elseif ((j==0) .and. (k>0)) then
        if (swap56) then
          msqv_cs(1,j,k)=ppmsqvx(pp(j,k,j,k))
        else
          ! msqv_cs already filled
        endif
      elseif ((j==0) .and. (k<0)) then
        if (swap56) then
          msqv_cs(1,j,k)=ppmsqvx(pp(j,k,j,k))
        else
          ! msqv_cs already filled
        endif
      endif
      
      enddo
      enddo

! DEBUG: only keep one color ordering
      msqv_cs(0,:,:)=zip
      msqv_cs(2,:,:)=zip
      
! return msqv array in usual format by performing sum
      msqv(:,:)=msqv_cs(0,:,:)+msqv_cs(1,:,:)+msqv_cs(2,:,:)

      return
      end
      
