!  Copyright (C) 2019-2021, respective authors of MCFM.
!
!  This program is free software: you can redistribute it and/or modify it under
!  the terms of the GNU General Public License as published by the Free Software
!  Foundation, either version 3 of the License, or (at your option) any later
!  version.
!
!  This program is distributed in the hope that it will be useful, but WITHOUT ANY
!  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
!  PARTICULAR PURPOSE. See the GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License along with
!  this program. If not, see <http://www.gnu.org/licenses/>
 
module qtResummation_params
    use types
    implicit none

    real(dp), save, public :: qtcutoff = 1.0d0

    real(dp), save, public :: qtmaxRes = 80d0
    real(dp), save, public :: qtminRes = 0d0

    real(dp), save, public :: qtmaxResexp = 80d0
    real(dp), save, public :: qtminResexp = 1.0d0

    real(dp), save, public :: transitionSwitch = 0.4d0

    logical, save, public :: enable_fixed_y = .false.
    real(dp), save, public :: fixed_y = 0.0d0
    
    logical, save, public :: enable_dsigma_dQ = .false.

    integer, save, public :: generations = 5

    logical, save, public ::  fix_alphas_nf5 = .false.

    logical, save, public :: scalevar_rapidity = .false.

    integer, save, public :: scalevar_rapidity_i = 0
!$omp threadprivate(scalevar_rapidity_i)

    real(dp), public, parameter :: &
        scalevar_rapidity_mult(1:2) = [6d0, 0.167d0]
end module
