!  Copyright (C) 2019-2021, respective authors of MCFM.
!
!  This program is free software: you can redistribute it and/or modify it under
!  the terms of the GNU General Public License as published by the Free Software
!  Foundation, either version 3 of the License, or (at your option) any later
!  version.
!
!  This program is distributed in the hope that it will be useful, but WITHOUT ANY
!  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
!  PARTICULAR PURPOSE. See the GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License along with
!  this program. If not, see <http://www.gnu.org/licenses/>
 
      subroutine couplz_cms(zxw_in)
      implicit none
      include 'types.f'
             
      include 'constants.f'
      include 'nf.f'
      include 'mxpart.f'
      include 'cplx.h'
      include 'zcouple.f'
      include 'zcouple_cms.f'
      include 'ewcharge.f'
c---calculate the couplings as given in Kunszt and Gunion
c---Modified to notation of DKS (ie divided by 2*sw*cw)
c---xw=sin^2 theta_w
      integer:: j
      complex(dp):: zxw_in
      rq1=q1
      rq2=q2
      zxw=zxw_in
      zsin2w=two*sqrt(zxw*(cone-zxw))
      do j=1,nf
      zl(j)=(tau(j)-two*Q(j)*zxw)/zsin2w
      zr(j)=      (-two*Q(j)*zxw)/zsin2w
      enddo

      zle=(-cone-two*(-cone)*zxw)/zsin2w
      zre=(-ctwo*(-cone)*zxw)/zsin2w

      zln=(+cone-two*(+czip)*zxw)/zsin2w
      zrn=czip

      return
      end
