!  Copyright (C) 2019-2021, respective authors of MCFM.
!
!  This program is free software: you can redistribute it and/or modify it under
!  the terms of the GNU General Public License as published by the Free Software
!  Foundation, either version 3 of the License, or (at your option) any later
!  version.
!
!  This program is distributed in the hope that it will be useful, but WITHOUT ANY
!  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
!  PARTICULAR PURPOSE. See the GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License along with
!  this program. If not, see <http://www.gnu.org/licenses/>
 
      function BSYALggpppp(e1,p2,p3,e4,za,zb,zab,zba)
      implicit none
      include 'src/Inc/types.f'
      complex(dp):: BSYALggpppp
      
C-----Authors: John Campbell and Keith Ellis, March 2012
C---- arXiv:1101.5947 [hep-ph], Eq. (92), fully Badger-compliant
C---- (These are twiddle functions, c.f.arXiv:1101.5947[hep-ph],Eq.(91))
      include 'src/Inc/constants.f'
      include 'src/Inc/nf.f'
      include 'src/Inc/mxpart.f'
      include 'src/Inc/cplx.h'
      include 'src/Inc/masses.f'
      include 'src/Inc/zprods_decl.f'
      include 'src/Inc/sprods_com.f'
      include 'src/Inc/zabprods_decl.f'
      include 'src/Inc/qdef.f'
      include 'src/Inc/massiveintegrals.f'
      real(dp):: s12,mt2
      complex(dp):: ze1xK12xK23xe4,BSYA0ggpppp,A0ggpppp
      integer:: e1,p2,p3,e4,j
 
C-----setup variable controlling integrals to be used,
C-----depending on whether p2=2 or 3
      j=p2-1

      mt2=mt**2
      s12=mt2+s(1,p2)

      A0ggpppp=BSYA0ggpppp(e1,p2,p3,e4,za,zb,zab,zba)

      ze1xK12xK23xe4=
     & zab(e1,q1,p2)*za(p2,e4)+zab(e1,q1,p3)*za(p3,e4)
     & +za(e1,p2)*zb(p2,p3)*za(p3,e4)

      BSYALggpppp =
     & +I41x2x3x4(j)*mt**3*za(e1,e4)*zb(p2,p3)**2
     & -F212(j)*(mt**3*zb(p2,p3)*(2d0*s12*za(e1,e4)-ze1xK12xK23xe4)
     &  /(za(p2,p3)*zab(p2,q1,p2)**2))
     & +0.5d0*A0ggpppp*(I2m-1d0)
     & -(mt*zb(p2,p3)*(za(e1,e4)*zab(p2,q1,p2)+ze1xK12xK23xe4)
     & /(2d0*za(p2,p3)*zab(p2,q1,p2))
     &  -mt*(za(e1,e4)*zab(p2,q1,p2)-za(p2,e1)*za(p3,e4)*zb(p2,p3))
     & /(3d0*za(p2,p3)**2))

      return
      end
