!  Copyright (C) 2019-2021, respective authors of MCFM.
!
!  This program is free software: you can redistribute it and/or modify it under
!  the terms of the GNU General Public License as published by the Free Software
!  Foundation, either version 3 of the License, or (at your option) any later
!  version.
!
!  This program is distributed in the hope that it will be useful, but WITHOUT ANY
!  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
!  PARTICULAR PURPOSE. See the GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License along with
!  this program. If not, see <http://www.gnu.org/licenses/>
 
      function BSYALslggpppp(e1,p2,e4,p3,za,zb,zab,zba)
      implicit none
      include 'src/Inc/types.f'
      complex(dp):: BSYALslggpppp
      
C-----Authors: John Campbell and Keith Ellis, March 2012
C---- arXiv:1101.5947 [hep-ph], Eq. (96)
C---- Modification wrt published version
C---- (These are twiddle functions, c.f.arXiv:1101.5947[hep-ph],Eq.(91))
      include 'src/Inc/constants.f'
      include 'src/Inc/nf.f'
      include 'src/Inc/mxpart.f'
      include 'src/Inc/cplx.h'
      include 'src/Inc/masses.f'
      include 'src/Inc/zprods_decl.f'
      include 'src/Inc/sprods_com.f'
      include 'src/Inc/zabprods_decl.f'
      include 'src/Inc/qdef.f'
      include 'src/Inc/massiveintegrals.f'
      real(dp):: s23,mt3
      integer:: e1,p2,p3,e4,j
      j=p2-1
      mt3=mt**3
      s23=s(p2,p3)
      BSYALslggpppp =  + I3m12x3x4(j) * ( 1/(za(p3,p2))/(za(p3,p2))*za(
     &    e1,p2)*za(e4,p3)*zb(p3,p2)*mt3 + 1/(za(p3,p2))/(za(p3,p2))*
     &    za(e1,p3)*za(e4,p2)*zb(p3,p2)*mt3 - 1/(zab(p2,q1,p2))/(za(p3,
     &    p2))/(za(p3,p2))*za(e1,p2)*za(e4,p2)*zb(p3,p2)*zab(p3,q1,p2)*
     &    mt3 - 1.D0/2.D0/(zab(p3,q1,p2))/(za(p3,p2))/(za(p3,p2))*za(e1
     &    ,p3)*za(e4,p3)*zb(p3,p2)*zab(p2,q1,p2)*mt3 + 1/(zab(p3,q1,p2)
     &    )/(za(p3,p2))/(za(p3,p2))*za(e4,e1)*zab(p2,q1,p2)*zab(p3,q1,
     &    p2)*mt3 )
      BSYALslggpppp = BSYALslggpppp + I312x3x4(j) * ( 1.D0/2.D0/(zab(p3
     &    ,q1,p2))/(za(p3,p2))/(za(p3,p2))*za(e1,p3)*za(e4,p3)*zb(p3,p2
     &    )*zab(p2,q1,p2)*mt3 + 1/(zab(p3,q1,p2))/(za(p3,p2))/(za(p3,p2
     &    ))*za(e4,e1)*zab(p2,q1,p2)*zab(p3,q1,p2)*mt3 )
      BSYALslggpppp = BSYALslggpppp + I3m13x2x4(j) * (  - 1/(za(p3,p2))
     &    /(za(p3,p2))*za(e1,p2)*za(e4,p3)*zb(p3,p2)*mt3 - 1/(za(p3,p2)
     &    )/(za(p3,p2))*za(e1,p3)*za(e4,p2)*zb(p3,p2)*mt3 - 1.D0/2.D0/(
     &    zab(p3,q1,p2))/(za(p3,p2))/(za(p3,p2))*za(e1,p3)*za(e4,p3)*
     &    zb(p3,p2)*zab(p3,q1,p3)*mt3 + 1/(zab(p3,q1,p2))/(za(p3,p2))/(
     &    za(p3,p2))*za(e4,e1)*zab(p3,q1,p2)*zab(p3,q1,p3)*mt3 - 1/(
     &    zab(p3,q1,p3))/(za(p3,p2))/(za(p3,p2))*za(e1,p2)*za(e4,p2)*
     &    zb(p3,p2)*zab(p3,q1,p2)*mt3 )
      BSYALslggpppp = BSYALslggpppp + I313x2x4(j) * ( 1.D0/2.D0/(zab(p3
     &    ,q1,p2))/(za(p3,p2))/(za(p3,p2))*za(e1,p3)*za(e4,p3)*zb(p3,p2
     &    )*zab(p3,q1,p3)*mt3 + 1/(zab(p3,q1,p2))/(za(p3,p2))/(za(p3,p2
     &    ))*za(e4,e1)*zab(p3,q1,p2)*zab(p3,q1,p3)*mt3 )
      BSYALslggpppp = BSYALslggpppp + I41x2x4x3 * (  - 1/(za(p3,p2))/(
     &    za(p3,p2))*za(e4,e1)*zab(p2,q1,p2)*s23*mt3 + 1/(za(p3,p2))/(
     &    za(p3,p2))*za(e4,e1)*zab(p3,q1,p3)**2*mt3 - 1.D0/2.D0/(zab(p3
     &    ,q1,p2))/(za(p3,p2))/(za(p3,p2))*za(e1,p3)*za(e4,p3)*zb(p3,p2
     &    )*zab(p2,q1,p2)*zab(p3,q1,p3)*mt3 )

c---- SB sign change: in comparison to published version, the above
c---- SB expression has an additional overall factor of -1
      BSYALslggpppp=-BSYALslggpppp
      return
      end
