!  Copyright (C) 2019-2021, respective authors of MCFM.
!
!  This program is free software: you can redistribute it and/or modify it under
!  the terms of the GNU General Public License as published by the Free Software
!  Foundation, either version 3 of the License, or (at your option) any later
!  version.
!
!  This program is distributed in the hope that it will be useful, but WITHOUT ANY
!  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
!  PARTICULAR PURPOSE. See the GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License along with
!  this program. If not, see <http://www.gnu.org/licenses/>
 
      subroutine qqb_wh_gaga(p,msq)
      implicit none
      include 'src/Inc/types.f'
c---Matrix element squared averaged over initial colors and spins
c for nwz=1
c     q(-p1)+qbar(-p2) -->  H  + W
c                           |    |
c                           |    --> nu(p3)+e^+(p4)
c                           |
c                           ---> ga(p5)+ga(p6)
c for nwz=-1
c     q(-p1)+qbar(-p2) -->  H  + W
c                           |    |
c                           |    --> e^-(p3)+nubar(p4)
c                           |
c                           ---> ga(p5)+ga(p6)
c---- Extension to photon decay contributed by Fabian Stoeckli
       
      include 'src/Inc/constants.f'
      include 'src/Inc/nf.f'
      include 'src/Inc/mxpart.f'
      include 'src/Inc/cplx.h'
      include 'src/Inc/masses.f'
      include 'src/Inc/ewcouple.f'
      include 'src/Inc/ckm.f'
      include 'src/Inc/hdecaymode.f'
      integer:: j,k
      real(dp):: p(mxpart,4)
      real(dp):: s,prop,fac,qqbWH,qbqWH,s56
      real(dp):: msq(-nf:nf,-nf:nf),hdecay      
      real(dp):: msqhgamgam

      s(j,k)=2*(p(j,4)*p(k,4)-p(j,1)*p(k,1)-p(j,2)*p(k,2)-p(j,3)*p(k,3))
      do j=-nf,nf
      do k=-nf,nf
      msq(j,k)=0._dp
      enddo
      enddo
!      s56=s(5,6)+2*mb**2
      if (hdecaymode=='none') then
         s56=s(5,5)
      else
         s56=s(5,6)
      endif

c---  cut to ensure hard process
c      if (
c     &      (s(5,6) < four*mbsq) 
c     & .or. (s(1,5)*s(2,5)/s(1,2) < mbsq) 
c     & .or. (s(1,6)*s(2,6)/s(1,2) < mbsq) ) return

c---calculate the 2 W propagators
      prop=     ((s(1,2)-wmass**2)**2+(wmass*wwidth)**2)
      prop=prop*((s(3,4)-wmass**2)**2+(wmass*wwidth)**2)

c-- note: in CMS, wmass**2 -> sqrt(wmass**4+(wmass*wwidth)**2)
      fac=xn*gwsq**3*sqrt(wmass**4+(wmass*wwidth)**2)/prop

      if (hdecaymode == 'none') then
         hdecay = one
      else
         hdecay=msqhgamgam(s56)
         hdecay=hdecay/((s56-hmass**2)**2+(hmass*hwidth)**2)
      endif
      fac=fac*hdecay

c-- Old form of this matrix element (modified to facilitate extension
c--- to H->WW decay)
c      spinave only (color factors cancel)
c       fac=spinave*gw**8*0.5_dp*mbsq*(s56-4._dp*mb**2)/prop
      qqbWH=aveqq*fac*s(1,4)*s(2,3)
      qbqWH=aveqq*fac*s(2,4)*s(1,3)

      do j=-nf,nf
      do k=-nf,nf
      if ((j > 0) .and. (k < 0)) msq(j,k)=Vsq(j,k)*qqbWH
      if ((j < 0) .and. (k > 0)) msq(j,k)=Vsq(j,k)*qbqWH
      enddo
      enddo
      return
      end

