!  Copyright (C) 2019-2021, respective authors of MCFM.
!
!  This program is free software: you can redistribute it and/or modify it under
!  the terms of the GNU General Public License as published by the Free Software
!  Foundation, either version 3 of the License, or (at your option) any later
!  version.
!
!  This program is distributed in the hope that it will be useful, but WITHOUT ANY
!  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
!  PARTICULAR PURPOSE. See the GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License along with
!  this program. If not, see <http://www.gnu.org/licenses/>
 
      subroutine BDKfillmp(k1,k2,k3,k4,k5,k6,mq,za,zb,ASLmp)
        use mod_qcdloop_c
      implicit none
      include 'src/Inc/types.f'
************************************************************************
*     Author: R.K. Ellis                                               *
*     August 2010.                                                     *
************************************************************************
      
      include 'src/Inc/constants.f'
      include 'src/Inc/nf.f'
      include 'src/Inc/mxpart.f'
      include 'src/Inc/cplx.h'
      include 'src/Inc/sprods_com.f'
      include 'src/Inc/zprods_decl.f'
      include 'src/Inc/scale.f'
      integer:: k1,k2,k3,k4,k5,k6,e
      complex(dp):: Lnrat,xl14,ASLmp(-2:0),C0(-1:0),
     & B0p23(-1:0),B0p3(-1:0),VV(-2:0)
      complex(dp):: BDK1211mp,atree,lo
      real(dp):: mqsq,p2Dp3,mq

      lo=atree('sl',k3,k2,k1,k4,k5,k6,zb,za)

      xl14=Lnrat(musq,-s(k1,k4))
      VV(-2)=-cone
      VV(-1)=-(cplx1(1.5_dp)+xl14)
      VV(0)=-(cplx1(4._dp)+1.5_dp*xl14+0.5_dp*xl14**2)

      mqsq=mq**2
c      write(6,*) 'BDKFill:musq',musq
      do e=-1,0
      C0(e)=qlI3(mqsq,s(k2,k3),mqsq,zip,mqsq,mqsq,musq,e)
      B0p23(e)=qlI2(s(k2,k3),mqsq,mqsq,musq,e)
      B0p3(e)=qlI2(mqsq,zip,mqsq,musq,e)
      enddo
      p2Dp3=0.5_dp*(s(k2,k3)-2._dp*mqsq)
    
C---Contribution of Final vertex function (massless case)
c       ASLmp(-2)=ASLmp(-2)-lo
c      ASLmp(-1)=ASLmp(-1)-(1.5_dp+xl23)*lo
c      ASL(0)=ASL(0)-(3.5._dp+1.5_dp*xl23+0.5_dp*xl23**2)*lo

C---Contribution of Final vertex function (massive  case)
C   (-2*p2.p3*C0(p2,p3,m,0,m)-3/2*B0(p23,m,m)+2*B0(p3,0,m)-1/2)

      VV(-1)=VV(-1)
     & +(-2._dp*p2Dp3*C0(-1)-1.5_dp*B0p23(-1)+2._dp*B0p3(-1))
      VV(0)=VV(0)
     & +(-2._dp*p2Dp3*C0(0)-1.5_dp*B0p23(0)+2._dp*B0p3(0)-chalf)

      ASLmp(-2)=VV(-2)*lo
      ASLmp(-1)=VV(-1)*lo
      ASLmp(0)=VV(0)*lo+BDK1211mp(k3,k2,k1,k4,k5,k6,zb,za)
       
      end
 
 
 

