!  Copyright (C) 2019-2021, respective authors of MCFM.
!
!  This program is free software: you can redistribute it and/or modify it under
!  the terms of the GNU General Public License as published by the Free Software
!  Foundation, either version 3 of the License, or (at your option) any later
!  version.
!
!  This program is distributed in the hope that it will be useful, but WITHOUT ANY
!  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
!  PARTICULAR PURPOSE. See the GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License along with
!  this program. If not, see <http://www.gnu.org/licenses/>
 
      subroutine qqb_wgam_v(p,msqv)
      implicit none
      include 'src/Inc/types.f'
      
C----Author R.K.Ellis August 2002
C====Virtual corrections to
c     q(-p1)+qbar(-p2)-->e^-(p3)+nu(p4)+gamma(p5)
      include 'src/Inc/constants.f'
      include 'src/Inc/nf.f'
      include 'src/Inc/mxpart.f'
      include 'src/Inc/cplx.h'
      include 'src/Inc/scheme.f'
      include 'src/Inc/qcdcouple.f'
      include 'src/Inc/ewcouple.f'
      include 'src/Inc/ckm.f'
      include 'src/Inc/zprods_decl.f'
      include 'src/Inc/nwz.f'
      include 'src/Inc/blha.f'
      integer:: j,k
      real(dp):: msqv(-nf:nf,-nf:nf),p(mxpart,4),qbq,qqb
      real(dp):: fac
      complex(dp):: agamtree,agamvirt

      call spinoru(5,p,za,zb)

      fac=ason2pi*cf*aveqq*2._dp*xn*gwsq**2*esq
    
      scheme='dred'
      if (nwz == -1) then
C ie ub-d
      
      if (useblha == 0) then   
      qbq=+fac*2._dp*real(
     .conjg(agamtree(1,2,3,4,5,za,zb,+1))*agamvirt(1,2,3,4,5,za,zb,+1))
     &    +fac*2._dp*real(
     .conjg(agamtree(1,2,3,4,5,za,zb,-1))*agamvirt(1,2,3,4,5,za,zb,-1))
      endif
C ie .e-_dpub
      qqb=+fac*2._dp*real(
     .conjg(agamtree(2,1,3,4,5,za,zb,+1))*agamvirt(2,1,3,4,5,za,zb,+1))
     &    +fac*2._dp*real(
     .conjg(agamtree(2,1,3,4,5,za,zb,-1))*agamvirt(2,1,3,4,5,za,zb,-1))

      elseif (nwz == +1) then 
C ie db-u
          
      if (useblha == 0) then
      qbq=+fac*2._dp*real(
     .conjg(agamtree(2,1,4,3,5,zb,za,+1))*agamvirt(2,1,4,3,5,zb,za,+1))
     &    +fac*2._dp*real(
     .conjg(agamtree(2,1,4,3,5,zb,za,-1))*agamvirt(2,1,4,3,5,zb,za,-1))
C ie u-db
      endif
   
      qqb=+fac*2._dp*real(
     .conjg(agamtree(1,2,4,3,5,zb,za,+1))*agamvirt(1,2,4,3,5,zb,za,+1))
     &    +fac*2._dp*real(
     .conjg(agamtree(1,2,4,3,5,zb,za,-1))*agamvirt(1,2,4,3,5,zb,za,-1))
       
      endif

      do j=-nf,nf
      do k=-nf,nf
c--- set msqv=0 to initalize
      msqv(j,k)=0._dp
          if ((j > 0) .and. (k < 0)) then
            msqv(j,k)=Vsq(j,k)*qqb
          elseif ((j < 0) .and. (k > 0)) then
            msqv(j,k)=Vsq(j,k)*qbq
          endif
      enddo
      enddo

      return
      end


      

      function agamvirt(p1,p2,p3,p4,p5,za,zb,hgamma)
      implicit none
      include 'src/Inc/types.f'
      complex(dp):: agamvirt
      
C----Author R.K.Ellis August 2002
c     q(-p1)+qbar(-p2)-->e^-(p3)+nu(p4)+gamma(p5)
      include 'src/Inc/constants.f'
      include 'src/Inc/nf.f'
      include 'src/Inc/mxpart.f'
      include 'src/Inc/cplx.h'
      include 'src/Inc/zprods_decl.f'
      include 'src/Inc/masses.f'
      complex(dp):: agamtree,vpole,fagamma,fbgamma,prop,vpl
      real(dp):: s34,s12
      integer:: p1,p2,p3,p4,p5,hgamma

      
      s34=real(za(p3,p4)*zb(p4,p3))
      s12=real(za(p1,p2)*zb(p2,p1))
      prop=s34/cplx2(s34-wmass**2,wmass*wwidth)
      vpl=vpole(s12)
      if    (hgamma == +1) then
        agamvirt=prop*(
     &  +Qd*fagamma(p1,p2,p3,p4,p5,za,zb)
     &  +Qu*fbgamma(p1,p2,p3,p4,p5,za,zb))
     &          +vpl*agamtree(p1,p2,p3,p4,p5,za,zb,+1)
      elseif (hgamma == -1) then
        agamvirt=prop*(
     &  +Qu*fagamma(p2,p1,p4,p3,p5,zb,za)
     &  +Qd*fbgamma(p2,p1,p4,p3,p5,zb,za))
     &          +vpl*agamtree(p1,p2,p3,p4,p5,za,zb,-1)
      endif
      
      return
      end
