!  Copyright (C) 2019-2021, respective authors of MCFM.
!
!  This program is free software: you can redistribute it and/or modify it under
!  the terms of the GNU General Public License as published by the Free Software
!  Foundation, either version 3 of the License, or (at your option) any later
!  version.
!
!  This program is distributed in the hope that it will be useful, but WITHOUT ANY
!  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
!  PARTICULAR PURPOSE. See the GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License along with
!  this program. If not, see <http://www.gnu.org/licenses/>
 
      function A6texact(s23,mt2)
        use mod_qcdloop_c
      implicit none
      include 'src/Inc/types.f'
      include 'src/Inc/constants.f'
      complex(dp)::A6texact,bb1
      real(dp)::s23,mt2,musq,s

c--- musq is irrelevant, set it to some value
      musq=mt2

c--- this is the form of the top loop vacuum polarization obtained
c--- after renormalization by subtraction at zero momentum transfer
c--- note: typo in Eq. (B12) of arXiv:1610.02189, sign of final term is wrong
      bb1 = qlI2(s23,mt2,mt2,musq,0)
      if(s23/mt2.lt.0.25_dp) then
         s = s23/mt2
         bb1 = log(musq/mt2)+s/6._dp*(1._dp+s/10._dp*(1._dp+s/7._dp*(1._dp+s/6._dp)))
      endif
      A6texact=-two/three*(
     &  (one+two*mt2/s23)*(bb1-qlI2(0._dp,mt2,mt2,musq,0))
     &   -one/three)

      return
      end
