!  Copyright (C) 2019-2021, respective authors of MCFM.
!
!  This program is free software: you can redistribute it and/or modify it under
!  the terms of the GNU General Public License as published by the Free Software
!  Foundation, either version 3 of the License, or (at your option) any later
!  version.
!
!  This program is distributed in the hope that it will be useful, but WITHOUT ANY
!  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
!  PARTICULAR PURPOSE. See the GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License along with
!  this program. If not, see <http://www.gnu.org/licenses/>
 
      subroutine hgggg_pppp(p1,p2,p3,p4,za,zb,Dcoeff,Ccoeff,Bcoeff,Rat)
c--- Coefficients of basis integrals in the helicity amplitude for
c----0 -> g+(p1) + g+(p2) + g+(p3) + g+(p4) + h
c--- with full top mass dependence
      implicit none
      include 'src/Inc/types.f'
      include 'src/Inc/mxpart.f'
      include 'src/Inc/constants.f'
      include 'src/ggHgg_mass/hgggglabels.f'
      include 'src/Inc/zprods_decl.f'
      integer p1,p2,p3,p4
      complex(dp) :: Dcoeff(dmax),Ccoeff(cmax),Bcoeff(bmax),R(cmax),Rat,
     & ppppD1x2x34,ppppD1x23x4,ppppD1x2x3,ppppC1x234
      
      Dcoeff(:)=czip
      Ccoeff(:)=czip
      Bcoeff(:)=czip

      
      Dcoeff(d1x2x34)=ppppD1x2x34(p1,p2,p3,p4,za,zb)
      Dcoeff(d2x3x41)=ppppD1x2x34(p2,p3,p4,p1,za,zb)
      Dcoeff(d3x4x12)=ppppD1x2x34(p3,p4,p1,p2,za,zb)
      Dcoeff(d4x1x23)=ppppD1x2x34(p4,p1,p2,p3,za,zb)

      Dcoeff(d1x4x32)=ppppD1x2x34(p1,p4,p3,p2,za,zb)
      Dcoeff(d2x1x43)=ppppD1x2x34(p2,p1,p4,p3,za,zb)
      Dcoeff(d3x2x14)=ppppD1x2x34(p3,p2,p1,p4,za,zb)
      Dcoeff(d4x3x21)=ppppD1x2x34(p4,p3,p2,p1,za,zb)
      
      Dcoeff(d1x23x4)=ppppD1x23x4(p1,p2,p3,p4,za,zb)
      Dcoeff(d2x34x1)=ppppD1x23x4(p2,p3,p4,p1,za,zb)
      Dcoeff(d3x41x2)=ppppD1x23x4(p3,p4,p1,p2,za,zb)
      Dcoeff(d4x12x3)=ppppD1x23x4(p4,p1,p2,p3,za,zb)
      
      Dcoeff(d1x2x3)=ppppD1x2x3(p1,p2,p3,p4,za,zb)
      Dcoeff(d2x3x4)=ppppD1x2x3(p2,p3,p4,p1,za,zb)
      Dcoeff(d3x4x1)=ppppD1x2x3(p3,p4,p1,p2,za,zb)
      Dcoeff(d4x1x2)=ppppD1x2x3(p4,p1,p2,p3,za,zb)

      Ccoeff(c1x234)=ppppC1x234(p1,p2,p3,p4,za,zb,R(c1x234))
      Ccoeff(c2x341)=ppppC1x234(p2,p3,p4,p1,za,zb,R(c2x341))
      Ccoeff(c3x412)=ppppC1x234(p3,p4,p1,p2,za,zb,R(c3x412))
      Ccoeff(c4x123)=ppppC1x234(p4,p1,p2,p3,za,zb,R(c4x123))

      
!      Rat=
!     & (ppppC1x234m2(p1,p2,p3,p4,za,zb)
!     & +ppppC1x234m2(p2,p3,p4,p1,za,zb)
!     & +ppppC1x234m2(p3,p4,p1,p2,za,zb)
!     & +ppppC1x234m2(p4,p1,p2,p3,za,zb))/two

      Rat=0.5_dp*(R(c1x234)+R(c2x341)+R(c3x412)+R(c4x123))
      return
      end
