!  Copyright (C) 2019-2021, respective authors of MCFM.
!
!  This program is free software: you can redistribute it and/or modify it under
!  the terms of the GNU General Public License as published by the Free Software
!  Foundation, either version 3 of the License, or (at your option) any later
!  version.
!
!  This program is distributed in the hope that it will be useful, but WITHOUT ANY
!  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
!  PARTICULAR PURPOSE. See the GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License along with
!  this program. If not, see <http://www.gnu.org/licenses/>
 
      subroutine pentbox(p1,p2,p3,p4,C)
      implicit none
      include 'src/Inc/types.f'
      include 'src/Inc/mxpart.f'
      include 'src/Inc/sprods_com.f'
      include 'src/ggHgg_mass/mtsq.f'
      integer p1,p2,p3,p4
      real(dp):: C(5),detSx16,s12,s13,s14,s23,s24,s34,s234,s123,s1234,
     & Del4

      s12=s(p1,p2)
      s13=s(p1,p3)
      s14=s(p1,p4)
      s23=s(p2,p3)
      s24=s(p2,p4)
      s34=s(p3,p4)
      
      s234=s23+s24+s34
      s123=s12+s13+s23
      s1234=s12+s13+s14+s23+s24+s34

      Del4=(s12*s34-s13*s24-s14*s23)**2-4._dp*s13*s14*s23*s24
      detSx16=s12*s23*s34*(s14*s23-(s12+s13)*(s24+s34))+mtsq*Del4

      C(1)=s23*s34
     & *(s12*(s234-s23)+s123*(s234-s34)-s23*(s1234-s34))
      C(2)=s34*(s1234*s23*(s123-2*s12)
     & +s123*(s34*(s123-s23)+s12*(s234+s23)-s234*s123))
      C(3)=(s1234*s23-s234*s123)
     & *(s12*s234+s34*s123-s234*s123+s23*(s1234-s12-s34))
      C(4)=s12*(s1234*s23*(s234-2*s34)
     & +s234*(s12*(s234-s23)+s34*(s123+s23)-s234*s123))
      C(5)=s12*s23
     & *(s34*(s123-s23)+s234*(s123-s12)-s23*(s1234-s12))

      C(:)=-0.5_dp*C(:)/detSx16

      return
      end
