!  Copyright (C) 2019-2021, respective authors of MCFM.
!
!  This program is free software: you can redistribute it and/or modify it under
!  the terms of the GNU General Public License as published by the Free Software
!  Foundation, either version 3 of the License, or (at your option) any later
!  version.
!
!  This program is distributed in the hope that it will be useful, but WITHOUT ANY
!  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
!  PARTICULAR PURPOSE. See the GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License along with
!  this program. If not, see <http://www.gnu.org/licenses/>
 
      function pmpmD1x2x3(p1,p2,p3,p4,za,zb)
      implicit none
!     This is a calculation for the process 1_g^+ 2_g^- 3_g^+ 4_g^- +H
!     Implementation of Eq.~(6.8) from arXiv:2002.04018 v2
      include 'src/Inc/types.f'
      include 'src/Inc/mxpart.f'
      include 'src/Inc/zprods_decl.f'
      include 'src/Inc/sprods_com.f'
      include 'src/ggHgg_mass/mtsq.f'
      include 'src/ggHgg_mass/Cred.f'
      include 'src/ggHgg_mass/I5to4.f'
      integer p1,p2,p3,p4
      real(dp):: s123
      complex(dp):: pmpmD1x2x3,pmpme4x1x2x3,pmpme1x2x3x4,zab2

      zab2(p1,p2,p3,p4)=za(p1,p2)*zb(p2,p4)+za(p1,p3)*zb(p3,p4)

      s123=s(p1,p2)+s(p1,p3)+s(p2,p3)

      pmpme1x2x3x4=
     & -mtsq*zb(p3,p4)*zab2(p4,p2,p3,p1)/(za(p3,p4)*zab2(p1,p2,p3,p4))
     & *za(p2,p4)**2*(1._dp+4._dp*mtsq*za(p1,p2)
     & /(za(p2,p4)*zab2(p1,p2,p3,p4)))

     & -mtsq*za(p2,p1)*zab2(p4,p2,p3,p1)/(zb(p2,p1)*zab2(p1,p2,p3,p4))
     & *zb(p3,p1)**2*(1._dp+4._dp*mtsq*zb(p4,p3) 
     & /(zb(p3,p1)*zab2(p1,p2,p3,p4)))

      pmpme4x1x2x3=
     & -mtsq*za(p2,p3)*zab2(p4,p1,p2,p3)/(zb(p2,p3)*zab2(p3,p1,p2,p4))
     & *zb(p1,p3)**2*(1._dp+4._dp*mtsq*zb(p4,p1)
     & /(zb(p1,p3)*zab2(p3,p1,p2,p4)))

     & -mtsq*zb(p1,p4)*zab2(p4,p1,p2,p3)/(za(p1,p4)*zab2(p3,p1,p2,p4))
     & *za(p2,p4)**2*(1._dp+4._dp*mtsq*za(p3,p2)
     & /(za(p2,p4)*zab2(p3,p1,p2,p4)))

      pmpmD1x2x3=
     &  pmpme4x1x2x3*Cred(1,I5to4(p4,p1,p2))
     & +pmpme1x2x3x4*Cred(5,I5to4(p1,p2,p3))
      
     & +za(p1,p2)*za(p2,p3)/(zab2(p1,p2,p3,p4)*zab2(p3,p1,p2,p4))*(
     & -2._dp*s(p1,p2)*s(p2,p3)*s123/za(p1,p3)**2
     & -0.5_dp*zb(p1,p2)*zb(p2,p3)*za(p2,p4)**2
     & *(s(p1,p4)+s(p2,p4)+s(p3,p4))/(za(p1,p4)*za(p3,p4))
     & +0.5_dp*zb(p1,p3)**2*s123
     & +2._dp*mtsq*(2._dp*zb(p1,p3)*s123/za(p1,p3)-zb(p1,p3)**2
     & +zb(p1,p2)*zb(p2,p3)*za(p2,p4)**2/(za(p1,p4)*za(p3,p4))
     & -zb(p2,p3)*zab2(p2,p1,p3,p4)*zab2(p4,p2,p3,p1)
     & /(za(p3,p4)*zab2(p1,p2,p3,p4))
     & +zb(p1,p2)*zab2(p2,p1,p3,p4)*zab2(p4,p1,p2,p3)
     & /(za(p1,p4)*zab2(p3,p1,p2,p4))))
     
      return
      end
