!  Copyright (C) 2019-2021, respective authors of MCFM.
!
!  This program is free software: you can redistribute it and/or modify it under
!  the terms of the GNU General Public License as published by the Free Software
!  Foundation, either version 3 of the License, or (at your option) any later
!  version.
!
!  This program is distributed in the hope that it will be useful, but WITHOUT ANY
!  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
!  PARTICULAR PURPOSE. See the GNU General Public License for more details.
!
!  You should have received a copy of the GNU General Public License along with
!  this program. If not, see <http://www.gnu.org/licenses/>
 
      function scppmmC23x41(p1,p2,p3,p4,za,zb)
      implicit none
!     Scalar loop
!     This is a calculation for the process 1_g^+ 2_g^+ 3_g^- 4_g^- +H
      include 'src/Inc/types.f'
      include 'src/Inc/mxpart.f'
      include 'src/Inc/zprods_decl.f'
      include 'src/ggHgg_mass/mtsq.f'
      integer p1,p2,p3,p4
      complex(dp):: scppmmC23x41,scppmmC23x41m0,ppmmC23x41m2
cc
      scppmmC23x41=scppmmC23x41m0(p1,p2,p3,p4,za,zb)
     & +mtsq*ppmmC23x41m2(p1,p2,p3,p4,za,zb)

      return
      end



      function scppmmC23x41m0(p1,p2,p3,p4,za,zb)
      implicit none
!     Scalar loop
!     This is a calculation for the process 1_g^+ 2_g^- 3_g^- 4_g^- +H
!     Implementation of Eq.~(7.13) from arXiv:2002.04018 v2
      include 'src/Inc/types.f'
      include 'src/Inc/mxpart.f'
      include 'src/Inc/zprods_decl.f'
      include 'src/Inc/sprods_com.f'
      integer p1,p2,p3,p4
      complex(dp):: scppmmC23x41m0,scpmpmC12x34m0,zab2,den
      real(dp):: s13,s14,s23,s24,s1234,Delta

      zab2(p1,p2,p3,p4)=za(p1,p2)*zb(p2,p4)+za(p1,p3)*zb(p3,p4)

      s13=s(p1,p3)
      s14=s(p1,p4)
      s23=s(p2,p3)
      s24=s(p2,p4)
      s1234=s(p1,p2)+s13+s14+s23+s24+s(p3,p4)
      Delta=(s1234-s14-s23)**2-4._dp*s14*s23
      den=zab2(p2,p1,p4,p3)*zab2(p1,p2,p3,p4)

      scppmmC23x41m0=-scpmpmC12x34m0(p2,p3,p1,p4,za,zb)
     &               -2._dp*Delta*((s13-s24)/den)**2
     &               -4._dp*zab2(p3,p1,p4,p2)*zab2(p4,p2,p3,p1)/den

      return
      end

